//---------------------------------------------------------------------------

#ifndef GlobalSearchH
#define GlobalSearchH

#include "AlgParameters.h"
#include "Solution.h"
#include <vector>
#include <stdio.h>

class CGlobalSearch
{
private:
   //! Obiekt przechowujcy rozwizanie
   CSolution Solution;
   //! Obiekt przechowujcy cala populacje
   CSolution Population, Pop2;
   //! Metoda tworzy rozwizanie startowe
   CSolution Initial(CAlgParameters &AlgParam, int iPopulationSize);
   //! Selekcja turniejowa
   CSolution TournamentSelection(CSolution Population, int iTournamentSize, bool bOptimMax);
   //! Selekcja ruletkowa
   CSolution RouletteSelection(CSolution Population, bool bOptimMax);
   //! Krzyowanie jednopunktowe
   CSolution Crossover1Point(CSolution Population, CAlgParameters &AlgParam);
   //! Krzyowanie dwupunktowe
   CSolution Crossover2Point(CSolution Population, CAlgParameters &AlgParam);
   //! Krzyowanie arytmetyczne
   CSolution CrossoverArythmetic(CSolution Population, CAlgParameters &AlgParam);
   //! Mutacja
   CSolution Mutation(CSolution Population, CAlgParameters &AlgParam);
   //! Metoda wyznacza optymalne rozwizanie z dwoch podanych
   TSol Check(TSol BestSolution, TSol BestPopulSol, bool bOptimMax);

public:

   CGlobalSearch(void);
   ~CGlobalSearch(void);

   //! Algorytm genetyczny
   CSolution GeneticAlgorithm(CAlgParameters &AlgParam);
   //! Metoda zwraca dotychczasowe wyliczone rozwizanie
   CSolution GetSolution(void);
   //! Metoda zwraca aktualna populacje
   CSolution GetPopulation(void);
};

//---------------------------------------------------------------------------
#endif
