#ifndef LocalSearchh
#define LocalSearchh

#include "AlgParameters.h"
#include "Solution.h"


class CLocalSearch
{
private:

   //! Obiekt przechowujcy rozwizanie
   CSolution Solution;

   //! Metoda tworzy rozwizanie startowe
   CSolution Initial(CAlgParameters &AlgParam);

public:

   CLocalSearch(void);
   ~CLocalSearch(void);

 	//! Metoda tworzy rozwiazanie na podstawie algorytmu Greedy
   CSolution Greedy(CAlgParameters &AlgParam);
 	//! Metoda tworzy rozwiazanie na podstawie algorytmu Steepest
   CSolution Steepest(CAlgParameters &AlgParam);
 	//! Metoda tworzy rozwiazanie na podstawie algorytmu SimulatedAnnealing
   CSolution SimulatedAnnealing(CAlgParameters &AlgParam);

   //! Metoda tworzy ssiedztwo dla algorytmow Greedy i Steepest
   void Neighbourhood(CAlgParameters &AlgParam, CSolution &Solution, int sol, double vals[]);
   //! Metoda tworzy ssiedztwo dla algorytmu SimulatedAnnealing
   void NeighbourhoodSA(CAlgParameters &AlgParam, CSolution &Solution, int sol,
                           double vals[], double newvals[], bool bTempOk);
                           
   //! Metoda zwraca dotychczasowe wyliczone rozwizanie
   CSolution GetSolution(void);
                              
};

#endif    
