#ifndef VarDatah
#define VarDatah

#include <vector>
#include <stdio.h>

#define MAXVAR 30
#define MAXFUNCLEN 200
#define MAXFUNNAME 20

//! Struktura opisujaca pojedyncz zmienn funkcji
typedef struct TVar
{
   char name[MAXFUNNAME];
   float min;
   float max;
   float value;
} TVar2;

//! Klasa zawierajca wszystkie zmienne funkcji
class CVarData
{
private:

   //! wektor zawierajacy wszystkie zmienne funkcji
   std::vector<TVar> vVariables;

public:

   	//! Konstruktor klasy
	   CVarData(void);
   	//! Destruktor klasy - zwolnienie pamieci
	   ~CVarData(void);

      //! Usuwa wszystkie zmienne
      void Clear(void);
      //! Zwraca nazw zmiennej o podanym indeksie
      char* GetVarName(int index);
      //! Zwraca dopuszczaln minimaln wartosc zmiennej o podanym indeksie
      float GetVarMin(int index);
      //! Zwraca dopuszczaln maksymaln wartosc zmiennej o podanym indeksie
      float GetVarMax(int index);
      //! Zwraca domysln wartosc zmiennej o podanym indeksie
      float GetVarValue(int index);
      //! Zwraca liczb zmiennych
      int GetNumberOfVar(void);
      //! Dodaje zmienn
      int AddVariable(char* name, float min, float max, float value);
      // Usuwa zmienn o podanej nazwie
      int DeletaVariable(char* name);
};

#endif
